﻿using Infragistics.Web.UI.ListControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TemplateFieldMultiColumnDropDown
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        

        protected void Page_Load(object sender, EventArgs e)
        {
            

            if (!IsPostBack)
            {
                Session["DS"] = GetData();
            }

            this.WebDataGrid1.DataSource = (DataTable)Session["DS"];
            this.WebDataGrid1.EnsureTemplates();
        }

        public DataTable GetData()
        {
            string[] names = { "Peter", "Maria", "John", "Gustavo", "Vladimir", "Todor" };

            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(Int16));
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Age", typeof(Int16));

            for (int i = 0; i < 6; i++)
            {
                var row = dt.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i];
                row[2] = 20 + i;
            }
            DataColumn[] columns = new DataColumn[1];
            columns[0] = dt.Columns["ID"];

            dt.PrimaryKey = columns;

            return dt;

        }

        public string ConvertDataTabletoString()
        {
            DataTable dt = (DataTable)Session["DS"];

            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            List<Dictionary<string, object>> rows = new List<Dictionary<string, object>>();
            Dictionary<string, object> row;
            foreach (DataRow dr in dt.Rows)
            {
                row = new Dictionary<string, object>();
                foreach (DataColumn col in dt.Columns)
                {
                    row.Add(col.ColumnName, dr[col]);
                }
                rows.Add(row);
            }
            return serializer.Serialize(rows);
        }

        protected void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            WebDropDown wdd = (WebDropDown)e.Row.Items[3].FindControl("wdd");
            if (wdd != null)
            {
                wdd.DataSource = (DataTable)Session["DS"];
                wdd.CurrentValue = "";
            }
        }
    }
}